using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using sato.pt;
using LAN_STL_CS;
using System.Net.Sockets;


namespace LAN_STL_CS
{
    public partial class frmMainForm : Form
    {

        /// <summary>
        /// RXgN^
        /// </summary>
        PtLan PtLan = new PtLan();

        string STX = "\x02";
        string ESC = "\x1b";
        string ETX = "\x03";

        public frmMainForm()
        {
            InitializeComponent();

        }


        /// <summary>
        /// I{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_end_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }


        /// <summary>
        /// v^ڑ{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_open_Click(object sender, EventArgs e)
        {
            //I[v߂l
            int retOpen = 0;

            //{^̐
            btn_open.Enabled = false;
            btn_label.Enabled = false;
            btn_close.Enabled = false;
            btn_end.Enabled = false;
            this.Refresh();

            //RXgN^
            PtLanParam LanPrm;
            //********** p[^ݒ **********
            LanPrm.IPaddress = txtLanIpA.Text + "." + txtLanIpB.Text + "." + txtLanIpC.Text + "." + txtLanIpD.Text;
            //|[g
            //|[g̓`FbNt邱
            LanPrm.Port = Convert.ToInt16(txtLanPort.Text);
            LanPrm.Timeout = 30000;

            //********** v^ڑ **********
            //I[v
            retOpen = PtLan.open(LanPrm);

            //********** v^ڑmF(󋵐ݒ) **********
            if (retOpen == Def.PT_OK)
            {
                txtStatus.Text = Convert.ToString("ڑ");

                //{^̐
                btn_open.Enabled = false;
                btn_label.Enabled = true;
                btn_close.Enabled = true;
                btn_cancel.Enabled = true;
            }
            else if (retOpen == Def.PT_NG)
            {
                txtStatus.Text = Convert.ToString("ڑs");

                //{^̐
                btn_open.Enabled = true;
                btn_label.Enabled = false;
                btn_close.Enabled = false;
                btn_end.Enabled = true;
            }
            else if (retOpen == Def.PT_PARAMERR)
            {
                txtStatus.Text = Convert.ToString("p[^G[");

                //{^̐
                btn_open.Enabled = false;
                btn_label.Enabled = true;
                btn_close.Enabled = true;
                btn_end.Enabled = true;
            }

            this.Refresh();
            this.Activate();
            this.Focus();
        }

        /// <summary>
        /// x{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_label_Click(object sender, EventArgs e)
        {
            //********** ۑ̃t@C擾@**********
            string fullAppName = Assembly.GetExecutingAssembly().Location;
            string fullAppPath = Path.GetDirectoryName(fullAppName);


            //t@C݃`FbN
            if (rdbPrnType1.Checked == true){
                if (System.IO.File.Exists(fullAppPath + @"\sato.bmp") == false){
                    MessageBox.Show("xpOtBbNt@C݂܂B", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    return;}
                
                if (int.Parse(txtLabelQty.Text) < 1){
                    MessageBox.Show("ssłB", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    return;
                }
            }
            else{
                if (System.IO.File.Exists(fullAppPath + @"\Label.txt") == false){
                    MessageBox.Show("xpt@C݂܂B", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    return;}
            }

            try
            {

                //{^̐
                btn_label.Enabled = false;
                btn_close.Enabled = false;
                btn_stop.Enabled = true;
                btn_cancel.Enabled = false;
                chbFinishQty.Enabled = false;
                chbPassQty.Enabled = false;
              
                //********** x **********
                byte[] bytData;
                PtOutputResult retLabel;

                //lݒ
                retLabel.Ret = Def.PTS_SYSTEMERR;
                Tx_FinishQty.Text = "0";

                //^C}[ĎJn
                tmrOutputResult.Enabled = true;

                //pXwR}hM
                if (chbPassQty.Checked) 
                {
                    retLabel = PtLan.outputLabel(LabelData_Pass());
                }

                for (int i = 1; i <= (rdbPrnType1.Checked ? int.Parse(txtLabelQty.Text) : 1); i++)
                {
                    //\twR}hM  
                    if (chbFinishQty.Checked)
                    {
                        retLabel = PtLan.outputLabel(LabelData_InitializeCount());
                    }

                    //ݒ
                    if (rdbPrnType1.Checked == true)
                    {
                        bytData = SbplData(i);
                    }
                    else
                    {
                        FileStream fs = new FileStream(fullAppPath + @"\Label.txt", FileMode.Open, FileAccess.Read);
                        BinaryReader br = new BinaryReader(fs);
                        bytData = br.ReadBytes((int)fs.Length);
                        fs.Close();
                        br.Close();
                    }

                    //xs
                    //f[^ŒA\tw莞̂ݓ\tmFs
                    retLabel = PtLan.outputLabel(bytData, (rdbPrnType1.Checked && chbFinishQty.Checked));
                    if (!showStatus(retLabel)) {return;} 
                    Tx_FinishQty.Text = i.ToString();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
            finally
            {
                //^C}[ĎI
                tmrOutputResult.Enabled = false;

                //{^̐
                btn_label.Enabled = true;
                btn_close.Enabled = true;
                btn_cancel.Enabled = true;
                btn_stop.Enabled = false;
                chbFinishQty.Enabled = true;
                chbPassQty.Enabled = true;
                this.Refresh();
                this.Activate();
                this.Focus();
            }
        }

         private bool showStatus(PtOutputResult retLabel){
             //********** xmF(󋵐ݒ) **********
             switch (retLabel.Ret)
             {
                 case Def.PTS_PRINTING:
                     txtStatus.Text = Convert.ToString("");
                     break;
                 case Def.PTS_ACK:
                     txtStatus.Text = Convert.ToString("x(ACK)");
                     break;
                 case Def.PTS_NAK:
                     switch (retLabel.Status)
                     {
                         case 0x6c:
                             txtStatus.Text = Convert.ToString("x\tG[");
                             break;
                         case 0x23:
                             txtStatus.Text = Convert.ToString("xzG[");
                             break;
                         case 0x24:
                             txtStatus.Text = Convert.ToString("\̓I[o[G[");
                             break;
                         case 0x25:
                             txtStatus.Text = Convert.ToString("V_sǃG[");
                             break;
                         case 0x2B:
                             txtStatus.Text = Convert.ToString("[U[p̃G[");
                             break;
                         default:
                             // LȊȌꍇ
                             txtStatus.Text = Convert.ToString("x(NAK)");
                             break;
                     }
                     break;
                 case Def.PTS_STOP:
                     txtStatus.Text = Convert.ToString("x~");
                     break;
                 case Def.PTS_TIMEOUT:
                     txtStatus.Text = Convert.ToString("^CAEgG[(vؒf)");
                     break;
                 case Def.PTS_SYSTEMERR:
                     txtStatus.Text = Convert.ToString("VXeG[");
                     break;
                 case Def.PTS_UNCONNECTION:
                     txtStatus.Text = Convert.ToString("ڑ");
                     break;
             }
             return (retLabel.Ret == Def.PTS_PRINTING || retLabel.Ret == Def.PTS_ACK);
        }

        // \twR}h
        private byte[] LabelData_InitializeCount()
        {
            string EditWk;
            // STXݒ肵܂
            EditWk = STX;

            // f[^M̊Jnݒ肵܂
            EditWk += ESC + "A";

            //  \tw ̕ҏW
            // (0)
            EditWk += ESC + "ES000000";

            // f[^M̏Iݒ肵܂
            EditWk += ESC + "Z";

            // ETXݒ肵܂
            EditWk += ETX;

            // STX ` ETX̕ҏW܂łoCg^zɕϊ܂
            return System.Text.Encoding.GetEncoding("Shift_JIS").GetBytes(EditWk);
        }

        // pXwR}h
        private byte[] LabelData_Pass()
        {
            string EditWk;
            // STXݒ肵܂
            EditWk = STX;

            // f[^M̊Jnݒ肵܂
            EditWk += ESC + "A";

            //  pXw ̕ҏW
            // (1)
            EditWk += ESC + "PA000001";

            // f[^M̏Iݒ肵܂
            EditWk += ESC + "Z";

            // ETXݒ肵܂
            EditWk += ETX;

            // STX ` ETX̕ҏW܂łoCg^zɕϊ܂
            return System.Text.Encoding.GetEncoding("Shift_JIS").GetBytes(EditWk);
        }

        private byte[] SbplData(int Serial)
        {
            string EditWk = string.Empty;

            string LogoPath; 

            string fullAppPath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);

            //t@C݃`FbN
            LogoPath = fullAppPath + @"\sato.bmp";

            // STXݒ肵܂
            EditWk = STX;

            // f[^M̊Jnݒ肵܂
            EditWk += ESC + "A";

            // pTCYݒ肵܂B
            // c(996ޯ)(1200ޯ)
            EditWk += ESC + "A1V996H1200";
            // R[hShiftJISɐݒ肵܂
            EditWk += ESC + "KC1";

            // rݒ肵܂
            // cʒu(240ޯ),ʒu(42ޯ)
            EditWk += ESC + "V240" + ESC + "H42";
            // (4ޯ),c(4ޯ),(360ޯ),c(1140ޯ)   
            EditWk += ESC + "FW0404V0360H1140";

            //  iR[h ̕ҏW
            // cʒu(300ޯ),ʒu(78ޯ),sb`(0ޯ),{(1{),c{(2{)
            EditWk += ESC + "V300" + ESC + "H78" + ESC + "P00" + ESC + "L0102";
            EditWk += ESC + "KDB" + "iR[h";

            // SAT123 ̕ҏW
            // cʒu(300ޯ),ʒu(378ޯ),{(2{),c{(2{)
            EditWk += ESC + "V300" + ESC + "H378" + ESC + "P00" + ESC + "L0202";
            EditWk += ESC + "X23,0SAT123";

            //  i ̕ҏW
            // cʒu(456ޯ),ʒu(78ޯ),{(1{),c{(2{)
            EditWk += ESC + "V456" + ESC + "H78" + ESC + "P00" + ESC + "L0102";
            EditWk += ESC + "KDB" + "i";

            //  LR4NX-FA ̕ҏW
            // cʒu(456ޯ),ʒu(378ޯ),{(1{),c{(2{)
            EditWk += ESC + "V456" + ESC + "H378" + ESC + "P00" + ESC + "L0202";
            EditWk += ESC + "X23,0LR4NX-FA";

            // o[R[h̕ҏW
            // cʒu(696ޯ),ʒu(258ޯ)
            EditWk += ESC + "V696" + ESC + "H258";
            // o[R[h(CODE39),o[g嗦(3{),o[Vn@(120ޯ)
            EditWk += ESC + "BD103120" + "*" + Serial.ToString().PadLeft(6, '0') + "*";

            // ' AԂ̕ҏW
            // cʒu(831ޯ),ʒu(258ޯ),{(1{),c{(1{)
            EditWk += ESC + "%0" + ESC + "V831" + ESC + "H258" + ESC + "P00" + ESC + "L0101";
            EditWk += ESC + "X24," + "0*" + Serial.ToString().PadLeft(6, '0') + "*";
            
            // S̕ҏW
            // 󎚎w,cʒu(96ޯ),ʒu(78ޯ)
            // t@C̃TCY擾܂
            System.IO.FileInfo fi = new System.IO.FileInfo(@LogoPath);
            long FileSize = fi.Length;

            EditWk += ESC + "%0" + ESC + "V0096" + ESC + "H0078";
            EditWk += ESC + "GM" + string.Format("{0:00000}", FileSize) + ",";

            // STX ` S̕ҏW܂łoCg^zɕϊ܂
            byte[] bStData = System.Text.Encoding.GetEncoding("Shift_JIS").GetBytes(EditWk);

            // t@CJ܂
            System.IO.FileStream fs = new System.IO.FileStream(LogoPath, System.IO.FileMode.Open, System.IO.FileAccess.Read);
            // t@CǂݍރoCg^z쐬܂
            byte[] bimgData = new byte[fs.Length];
            // t@C̓eׂēǂݍ݂܂
            fs.Read(bimgData, 0, bimgData.Length);
            // t@C܂
            fs.Close();

            // ݒ(1)܂
            EditWk = ESC + "Q1";

            // f[^M̏Iݒ肵܂
            EditWk += ESC + "Z";

            // ETXݒ肵܂
            EditWk += ETX;

            //  ` ETX܂łoCg^zɕϊ܂
            byte[] bEnData = System.Text.Encoding.GetEncoding("Shift_JIS").GetBytes(EditWk);

            // f[^yуOtBbNf[^oCg^zɌ܂
            byte[] bPrData = new byte[bStData.Length + bimgData.Length + bEnData.Length];
            Array.Copy(bStData, 0, bPrData, 0, bStData.Length);
            Array.Copy(bimgData, 0, bPrData, bStData.Length, bimgData.Length);
            Array.Copy(bEnData, 0, bPrData, bStData.Length + bimgData.Length, bEnData.Length);

            return bPrData;
        }
        /// <summary>
        /// SpJISR[h擾
        /// </summary>
        /// <param name="strSiftJis"></param>
        static public string KanjiConv(string strSiftJis)
        {
            string strConv;         // [Nϐ
            string strMoji;         // ϊΏە 
            string strHex;          // VtgJISR[h
            int bytUpByte;          // ʃoCg
            int bytDownByte;        // ʃoCg

            Encoding sjisEnc = Encoding.GetEncoding("Shift_JIS");

            // [Nϐ̏܂
            strConv = string.Empty;

            // JԂ܂i1ϊ܂j
            for (int i = 0; i < strSiftJis.Length; i++)
            {
                // ϊΏەVtgJISR[h擾܂
                strMoji = strSiftJis.Substring(i, 1);
                byte[] bytes = sjisEnc.GetBytes(strMoji);
                strHex = BitConverter.ToString(bytes);

                // R[hɂ菈s܂
                if (strHex == "20")
                {
                    break;
                }

                bytUpByte = bytes[0];       // ʃoCg擾܂
                bytDownByte = bytes[1];     // ʃoCg擾܂

                // ʃoCg̏
                if (bytUpByte >= 0xe0)
                {
                    bytUpByte = bytUpByte - 0x40;
                }
                bytUpByte = (bytUpByte - 0x81) * 2 + 0x21;

                // ʃoCg̏
                if (bytDownByte > 0x7f)
                {
                    bytDownByte = bytDownByte - 1;
                }

                // ʃoCg̏ 
                if (bytDownByte > 0x9d)
                {
                    bytUpByte = bytUpByte + 1;
                    bytDownByte = bytDownByte - (0x9e - 0x21);
                }
                else
                {
                    bytDownByte = bytDownByte - (0x40 - 0x21);
                }

                // [NϐɏʃoCgEʃoCgݒ肵܂
                strConv += BitConverter.ToString(BitConverter.GetBytes(bytUpByte)).Substring(0, 2);
                strConv += BitConverter.ToString(BitConverter.GetBytes(bytDownByte)).Substring(0, 2);
            }
            return strConv;
        }
        /// <summary>
        /// ڑI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>        
        private void btn_close_Click(object sender, EventArgs e)
        {
            //********** v^ؒf **********
            bool retClose = false;

            //N[Y
            retClose = PtLan.close();
            
            //********** v^ؒfmF(󋵐ݒ) **********
            if (retClose == true)
            {
                txtStatus.Text = Convert.ToString("ؒf");

                //{^̐
                btn_open.Enabled = true;
                btn_label.Enabled = false;
                btn_close.Enabled = false;
                btn_cancel.Enabled = false;
                btn_end.Enabled = true;
            }
            else if (retClose == false)
            {
                txtStatus.Text = Convert.ToString("ؒfs");
            }

            this.Refresh();
            this.Activate();
            this.Focus();
        }

        /// <summary>
        /// 󋵊Ď^C}
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>        
        private void tmrOutputResult_Tick(object sender, EventArgs e)
        {
            int ret = Def.PRN_NONE;
            //󋵊Ď
            ret = PtLan.getOutputStatus();

            //󋵐ݒ
            switch (ret)
            {
                case Def.PRN_NONE:
                    txtStatus.Text = Convert.ToString("t");
                    break;
                case Def.PRN_PRINTING:
                    txtStatus.Text = Convert.ToString("");
                    break;
                case Def.PRN_PASS_WAITING:
                    txtStatus.Text = Convert.ToString("ʉߒ");
                    break;
                case Def.PRN_LABEL_SEND:
                    txtStatus.Text = Convert.ToString("xf[^M");
                    break;
                case Def.PRN_END_WAITING:
                    txtStatus.Text = Convert.ToString("\t҂");
                    break;
                case Def.PRN_OFF_LINE:
                    txtStatus.Text = Convert.ToString("ItC");
                    break;
                case Def.PRN_HEAD_OPEN:
                    txtStatus.Text = Convert.ToString("wbhI[v");
                    break;
                case Def.PRN_PAPER_END:
                    txtStatus.Text = Convert.ToString("y[p[Gh");
                    break;
                case Def.PRN_RIBON_END:
                    txtStatus.Text = Convert.ToString("{Gh");
                    break;
                case Def.PRN_SENSOR_ERROR:
                    txtStatus.Text = Convert.ToString("ZTG[");
                    break;
                case Def.PRN_COVER_OPENING:
                    txtStatus.Text = Convert.ToString("Jo[I[v");
                    break;
            }
        }

        /// <summary>
        /// MXgbv{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>        
        private void btn_stop_Click(object sender, EventArgs e)
        {
            //********** STOP **********
            PtLan.stop();
        }

        /// <summary>
        /// LZM{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>        
        private void btn_Cancel_Click(object sender, EventArgs e)
        {
            //{^̐
            btn_label.Enabled = false;
            btn_close.Enabled = false;
            btn_stop.Enabled = true;
            btn_cancel.Enabled = false;
            //********** LZ **********
            PtReceiveData retCancel;
            retCancel.Ret = Def.PTS_SYSTEMERR;
            retCancel = PtLan.sendCancel();

            //********** LZmF(󋵐ݒ) **********
            switch (retCancel.Ret)
            {
                case Def.PTS_END_RECEIVE:
                    txtStatus.Text = Convert.ToString("LZ");
                    break;
                case Def.PTS_UNCONNECTION:
                    txtStatus.Text = Convert.ToString("ڑ");
                    break;
                case Def.PTS_STOP:
                    txtStatus.Text = Convert.ToString("~");
                    break;
                case Def.PTS_TIMEOUT:
                    txtStatus.Text = Convert.ToString("^CAEgG[(vؒf)");
                    break;
                case Def.PTS_SYSTEMERR:
                    txtStatus.Text = Convert.ToString("VXeG[");
                    break;
            }
            btn_label.Enabled = true;
            btn_stop.Enabled = false;
            btn_close.Enabled = true;
            btn_cancel.Enabled = true;
        }

        //t@CǍɖw񊈐
        private void rdbPrnType_CheckedChanged(object sender, EventArgs e)
        {
            txtLabelQty.Enabled = rdbPrnType1.Checked;
        }
    }
}