using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.Text.RegularExpressions;
using System.Linq;

namespace sato.pt
{
    /// <summary>
    /// LAN(TCP/IP)Ńv^s܂B
    /// </summary>
    public class PtLan
    {
        #region 萔
        private const int IP_NUM_DIGITS = 15;   // IP
        private const int PORT_NUM_MAX = 9999;  // |[gő包
        private const int PORT_NUM_MIN = 0;     // |[gő包

        #endregion

        #region O[oϐ
        private PtLanParam grvPlpParam;                 // ʐMp[^
        private Socket grvSockClient = null;            // \Pbg

        private int grvIntOutputStatus = Def.PRN_NONE;  // is
        private bool grvBlnStopFlg = false;             // XgbvtO
        private bool grvBlnTimeout = false;             // ^CAEgtO
        private bool grvBlnPrintingNow = false;         // tO
        #endregion

        #region RXgN^
        /// <summary>
        /// RXgN^
        /// </summary>
        public PtLan()
        {
            grvPlpParam.IPaddress = "192.168.1.1";
            grvPlpParam.Port = 1024;
            grvPlpParam.Timeout = 500;
        }
        #endregion

        #region J\bh
        /// <summary>
        /// \PbgI[v
        /// </summary>
        /// <param name="plpPrm">TCP/IP̐ݒ</param>
        /// <returns>
        /// I[v̐
        /// PT_OK:I[v
        /// PT_NG:I[vs
        /// PT_PARAMERR:p[^G[
        /// PT_SYSTEMERR:VXeG[
        /// </returns>
        public int open(PtLanParam plpPrm)
        {
            int intRet = Def.PT_OK;
            IPEndPoint grvSockIpe = null;   // lbg[NGh|Cg
            bool blnPramaChack = true;
            bool blnCloseflg = true;

            Common.outputDebugLog("PtLan", "open", "====================================Jn====================================");
            try
            {
                /***********************
                 * LANڑ̐ݒ擾
                 ***********************/
                grvPlpParam = plpPrm;

                /***********************
                 * p[^`FbN
                ***********************/
                // IPAhX`FbN
                // e`FbN
                // XXX.XXX.XXX.XXXmF
                blnPramaChack = IsIPAddress(grvPlpParam.IPaddress);

                // `FbN
                if (grvPlpParam.IPaddress.Length > IP_NUM_DIGITS)
                {
                    blnPramaChack = false;
                }

                // |[g`FbN
                // ݒ͈̓`FbN
                if (grvPlpParam.Port > PORT_NUM_MAX || grvPlpParam.Port < PORT_NUM_MIN)
                {
                    blnPramaChack = false;
                }

                /***********************
                 * \PbgI[v
                 ***********************/
                // \Pbg̏ԊmF
                if (grvSockIpe != null)
                {
                    // \PbgJςȂȂ̂ňUؒf
                    blnCloseflg = close();
                }

                // I[v\H
                if (blnCloseflg)
                {
                    // `FbNOKȂ΃\PbgI[v
                    if (blnPramaChack)
                    {
                        // ݒ
                        // ڽϊ
                        grvSockIpe = new IPEndPoint(IPAddress.Parse(grvPlpParam.IPaddress), grvPlpParam.Port);
                        // č쐬
                        grvSockClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                        Common.outputDebugLog("PtLan", "open", "IPAhX:" + grvPlpParam.IPaddress);
                        Common.outputDebugLog("PtLan", "open", "|[g:" + grvPlpParam.Port);
                        Common.outputDebugLog("PtLan", "open", "M^CAEgݒF" + grvPlpParam.Timeout);

                        // I[v
                        grvSockClient.Connect(grvSockIpe);
                        Common.outputDebugLog("PtLan", "open", "RlNg");

                    }
                    else
                    {
                        // p[^G[Ԃ
                        intRet = Def.PT_PARAMERR;

                        Common.outputDebugLog("PtLan", "open", "p[^G[");
                    }
                }
                else
                {
                    // ڑsԂ
                    intRet = Def.PT_NG;

                    Common.outputDebugLog("PtLan", "open", "M̂ߐڑs");
                }
            }
            catch (ArgumentNullException ane)
            {   // grvSockClient.Connect():remoteEP  null Q (Visual Basic ł Nothing) łB 
                // G[Oo
                Common.outputLog("PtLan", "open", "remoteEP  null QƂł\t" + ane.Message);

                // G[̂߁A\PbgN[Y
                close();

                intRet = Def.PT_NG;
            }
            catch (SocketException se)
            {   // grvSockClient.Connect():\Pbgւ̃ANZX݂ĂƂɃG[܂B
                // G[Oo
                Common.outputLog("PtLan", "open", "\Pbgւ̃ANZX݂ĂƂɃG[܂\t" + se.Message);

                // G[̂߁A\PbgN[Y
                close();

                intRet = Def.PT_NG;
            }
            catch (ObjectDisposedException ode)
            {   // grvSockClient.Connect():Socket ͕Ă܂B

                // G[Oo
                Common.outputLog("PtLan", "open", "Socket ͕Ă܂\t" + ode.Message);

                // G[̂߁A\PbgN[Y
                close();

                intRet = Def.PT_NG;
            }
            catch (InvalidOperationException se)
            {   // grvSockClient.Connect():Socket  Listen słB

                // G[Oo
                Common.outputLog("PtLan", "open", "Socket  Listen sł\t" + se.Message);

                // G[̂߁A\PbgN[Y
                close();

                intRet = Def.PT_NG;
            }
            catch (Exception e)
            {
                // G[Oo
                Common.outputLog("PtLan", "open", e.Message);

                // G[̂߁A\PbgN[Y
                close();

                intRet = Def.PT_NG;
            }

            Common.outputDebugLog("PtLan", "open", "====================================I====================================");
            return intRet;
        }

        /// <summary>
        /// LAN̐ݒ擾
        /// </summary>
        /// <returns>
        /// !NULL:ݒe
        /// </returns>
        public PtLanParam getParam()
        {
            Common.outputDebugLog("PtLan", "getParam", "LAN̐ݒԓ");
            /***********************
             * LAN̐ݒԓ
             ***********************/
            return grvPlpParam;
        }

        /// <summary>
        /// xs
        /// v^̃Xe[^XmF܂łs
        /// is󋵂́ugetOutputStatusvŊmF\
        /// ́uShift_JISvőMs
        /// </summary>
        /// <param name="bytData">e</param>
        /// <returns>
        /// !NULL:
        /// </returns>
        public PtOutputResult outputLabel(byte[] bytData, bool checkFinishedCount = false)
        {
            PtOutputResult porRet;
            PtReceiveData prdResult;
            byte bytRes;

            porRet.Ret = Def.PTS_SYSTEMERR;
            porRet.Status = 0x00;
            porRet.StatusData = new byte[11];
            porRet.FinishedCount = 0;

            Common.outputDebugLog("PtLan", "outputLabel", "====================================Jn====================================");
            try
            {
                // ł͂ȂH
                if (grvBlnPrintingNow == false)
                {
                    // Jn
                    grvBlnPrintingNow = true;

                    Common.outputDebugLog("PtLan", "outputLabel", "Jn");

                    grvIntOutputStatus = Def.PTS_PRINTING;  // 
                    DoEvent();
                    Common.outputDebugLog("PtLan", "outputLabel", "OutputStatusF" + grvIntOutputStatus);

                    // v^Xe[^X̊mF(MO)
                    prdResult = PtChkPrintTransmissionCondition();

                    // \H
                    if (prdResult.Ret == Def.PTS_END_RECEIVE)
                    {
                        if (Common.chkPrintTransmissionCondition(prdResult.ReceiveData[Common.STR_INDEX]) == Common.STR_OK)
                        {
                            grvIntOutputStatus = Def.PRN_LABEL_SEND;  // xf[^M
                            DoEvent();
                            Common.outputDebugLog("PtLan", "outputLabel", "OutputStatusF" + grvIntOutputStatus);

                            // f[^M
                            prdResult = sendCommand(bytData);
                            if (prdResult.Ret == Def.PTS_END_RECEIVE)
                            {
                                bytRes = prdResult.ReceiveData[0];  // ACK,NAK̑ޔ

                                grvIntOutputStatus = Def.PRN_END_WAITING;  // ҂
                                DoEvent();
                                Common.outputDebugLog("PtLan", "outputLabel", "OutputStatusF" + grvIntOutputStatus);

                                // v^Xe[^X̊mF(҂)
                                prdResult = PtChkPrintCompletionConditionLabel(checkFinishedCount);

                                // H
                                if (prdResult.Ret == Def.PTS_END_RECEIVE)
                                {
                                    if (Common.chkPrintCompletionCondition(prdResult.ReceiveData[Common.STR_INDEX]) == Common.STR_OK)
                                    {
                                        // ߂lZbg
                                        porRet.Ret = bytRes;
                                        porRet.Status = prdResult.ReceiveData[Common.STR_INDEX];
                                        porRet.StatusData = prdResult.ReceiveData;
                                        porRet.FinishedCount = int.Parse(Encoding.GetEncoding("Shift_JIS").GetString(prdResult.ReceiveData.Skip(4).Take(6).ToArray()));
                                    }
                                    else
                                    {
                                        // G[eZbg
                                        porRet.Ret = Def.PTS_NAK;
                                        porRet.Status = prdResult.ReceiveData[Common.STR_INDEX];
                                        porRet.StatusData = prdResult.ReceiveData;
                                    }
                                    grvIntOutputStatus = Def.PRN_NONE;  // t
                                    Common.outputDebugLog("PtLan", "outputLabel", "OutputStatusF" + grvIntOutputStatus);
                                }
                                else
                                {
                                    // G[eZbg
                                    porRet.Ret = prdResult.Ret;
                                }
                            }
                            else
                            {
                                // G[eZbg
                                porRet.Ret = prdResult.Ret;
                            }
                        }
                        else
                        {
                            // G[eZbg
                            porRet.Ret = Def.PTS_NAK;
                            porRet.Status = prdResult.ReceiveData[Common.STR_INDEX];
                            porRet.StatusData = prdResult.ReceiveData;
                        }
                    }
                    else
                    {
                        // G[eZbg
                        porRet.Ret = prdResult.Ret;
                    }

                    // I
                    grvBlnPrintingNow = false;
                    Common.outputDebugLog("PtLan", "outputLabel", "I");
                }
                else
                {
                    // ɂAts
                    porRet.Ret = Def.PTS_PRINTING;
                    Common.outputDebugLog("PtLan", "outputLabel", "ɂAts");
                }
            }
            catch (Exception e)
            {
                // G[Oo
                Common.outputLog("PtLan", "outputLabel", e.Message);
                porRet.Ret = Def.PTS_SYSTEMERR;

            }

            Common.outputDebugLog("PtLan", "outputLabel", "߂lF" + porRet.Ret);
            Common.outputDebugLog("PtLan", "outputLabel", "߂l(Xe[^X)F" + (char)porRet.Status);
#if DEBUG
            String strLog = "";
            for (int ii = 0; ii < porRet.StatusData.Length; ii++)
            {
                strLog = strLog + (char)porRet.StatusData[ii];
            }

            Common.outputDebugLog("PtLan", "outputLabel", "߂l(f[^)F" + strLog);
#endif
            Common.outputDebugLog("PtLan", "outputLabel", "====================================I====================================");
            return porRet;
        }

        /// <summary>
        /// 󋵂擾
        /// </summary>
        /// <returns>
        /// 
        /// </returns>
        public int getOutputStatus()
        {
            Common.outputDebugLog("PtLan", "getOutputStatus", "󋵕ԓ");
            return grvIntOutputStatus;
        }

        /// <summary>
        /// MAM𒆎~
        /// </summary>
        /// <returns>
        /// 
        /// </returns>
        public void stop()
        {
            Common.outputDebugLog("PtLan", "stop", "MAM𒆎~");
            grvBlnStopFlg = true;
        }

        /// <summary>
        /// v^̃Xe[^X擾
        /// </summary>
        /// <returns>
        /// 
        /// </returns>
        public PtReceiveData getPtStatus()
        {
            byte[] bytEnq = new byte[1];

            bytEnq[0] = Common.ENQ;

            Common.outputDebugLog("PtLan", "getPtStatus", "R}h:" + bytEnq[0]);
            // Xe[^XM
            return sendCommand(bytEnq);
        }

        /// <summary>
        /// R}h𑗐M
        /// R}h𑗐MA肩̉M鏊܂łsB
        /// </summary>
        /// <param name="bytCommand">MR}hi[oCgz</param>
        /// <returns>
        /// 
        /// </returns>
        public PtReceiveData sendCommand(byte[] bytCommand)
        {
            PtReceiveData pstRet;

            // 
            pstRet.ReceiveLen = 0;
            pstRet.ReceiveData = new byte[0];
            pstRet.Ret = Def.PTS_END_RECEIVE;

            Common.outputDebugLog("PtLan", "sendCommand", "====================================Jn====================================");
            try
            {
                // ڑH
                if (grvSockClient != null)
                {
                    // M
                    Common.outputDebugLog("PtLan", "sendCommand", "M");
                    pstRet.Ret = sockSend(bytCommand);
                    if (pstRet.Ret == 0)
                    {
                        // M
                        Common.outputDebugLog("PtLan", "sendCommand", "M");
                        pstRet = sockReceive();
                    }
                }
                else
                {
                    Common.outputDebugLog("PtLan", "sendCommand", "ڑɂAts");
                    // ڑɂAts
                    pstRet.Ret = Def.PTS_UNCONNECTION;
                }
            }
            catch (Exception e)
            {					// Error
                // G[Oo
                Common.outputLog("PtLan", "sendCommand", e.Message);
                pstRet.Ret = Def.PTS_SYSTEMERR;
                return pstRet;
            }

            Common.outputDebugLog("PtLan", "sendCommand", "߂lF" + pstRet.Ret);
#if DEBUG
            String strLog = "";
            for (int ii = 0; ii < pstRet.ReceiveLen; ii++)
            {
                strLog = strLog + (char)pstRet.ReceiveData[ii];
            }

            Common.outputDebugLog("PtLan", "sendCommand", "߂l(f[^)F" + strLog);
#endif
            Common.outputDebugLog("PtLan", "sendCommand", "====================================I====================================");
            return pstRet;
        }

        /// <summary>
        /// LZR}h𑗐M
        /// </summary>
        /// <returns>
        /// 
        /// </returns>
        public PtReceiveData sendCancel()
        {
            byte[] bytCan = new byte[1];

            bytCan[0] = Common.CAN;

            Common.outputDebugLog("PtLan", "sendCancel", "R}h:" + bytCan[0]);
            // LZR}h𑗐M
            return sendCommand(bytCan);
        }

        /// <summary>
        /// \PbgN[Y
        /// </summary>
        /// <returns>
        /// 
        /// </returns>
        public bool close()
        {
            bool bolRet = true;

            Common.outputDebugLog("PtLan", "close", "====================================Jn====================================");
            // ł͂ȂH
            if (grvBlnPrintingNow == false)
            {
                // \PbgN[Y
                if (grvSockClient != null)
                {
                    try
                    {
                        Common.outputDebugLog("PtLan", "close", "\PbgN[Y");
                        grvSockClient.Shutdown(SocketShutdown.Both);
                        grvSockClient.Close();
                        grvSockClient = null;
                    }
                    catch (SocketException se)
                    {   // \Pbgւ̃ANZX݂ĂƂɃG[܂B
                        // G[Oo
                        Common.outputLog("PtLan", "close", "\Pbgւ̃ANZX݂ĂƂɃG[܂\t" + se.Message);

                        bolRet = false;
                    }
                    catch (ObjectDisposedException ode)
                    {   // Socket ͕Ă܂B
                        // G[Oo
                        Common.outputLog("PtLan", "close", "Socket ͕Ă܂\t" + ode.Message);

                        bolRet = false;
                    }
                    catch (Exception e)
                    {
                        // G[Oo
                        Common.outputLog("PtLan", "close", e.Message);

                        bolRet = false;
                    }
                }
            }
            else
            {
                Common.outputDebugLog("PtLan", "close", "Ȃ̂ŁAN[Ys");
                // Ȃ̂ŁAN[Ys
                bolRet = false;
            }

            Common.outputDebugLog("PtLan", "close", "====================================I====================================");
            return bolRet;
        }

        #endregion

        #region J\bh
        /// <summary>
        /// IPAhX`FbN
        /// </summary>
        /// <param name="prmBytSendData">`FbNIPAhX</param>
        /// <returns>
        /// TRUE:OK
        /// FALSE:NG
        /// </returns>
        private bool IsIPAddress(string prmStrIp)
        {
            if (Regex.IsMatch(prmStrIp, "^[0-2]?[0-9]?[0-9]+\\.[0-2]?[0-9]?[0-9]+\\.[0-2]?[0-9]?[0-9]+\\.[0-2]?[0-9]?[0-9]+$"))
            {
                string[] strIp = prmStrIp.Split(".".ToCharArray());

                if (strIp.Length.Equals(4)
                && int.Parse(strIp[0]) <= byte.MaxValue
                && int.Parse(strIp[1]) <= byte.MaxValue
                && int.Parse(strIp[2]) <= byte.MaxValue
                && int.Parse(strIp[3]) <= byte.MaxValue)
                {
                    return true;
                }
            }
            return false;
        }

        /// <summary>
        /// M
        /// </summary>
        /// <param name="prmBytSendData">Mf[^i[oCgz</param>
        /// <returns>
        /// 0FI
        /// PTS_STOPF~
        /// PTS_TIMEOUTF^CAEg
        /// PTS_SYSTEMERRFVXeG[
        /// </returns>
        private byte sockSend(byte[] prmBytSendData)
        {
            byte bytRet = 0;

            Common.outputDebugLog("PtLan", "sockSend", "====================================Jn====================================");
            try
            {
                // ~ꂽH
                DoEvent();
                if (PtChkStopFlg() == true)
                {
                    Common.outputDebugLog("PtLan", "sockSend", "MOɃ[U蒆~t");
                    bytRet = Def.PTS_STOP;
                }
                else
                {
                    Common.outputDebugLog("PtLan", "sockSend", "MJn");
                    // Mobt@NA
                    clrSockReceive();
                    // M
                    grvSockClient.Send(prmBytSendData, 0, prmBytSendData.Length, SocketFlags.None);
                    Common.outputDebugLog("PtLan", "sockSend", "M");
                }
            }
            catch (ArgumentNullException ae)
            {   //grvSockClient.Send:nꂽ buffer  null Q (Visual Basic ł Nothing) łB 
                // G[Oo
                Common.outputLog("PtLan", "sockSend", "Mobt@NULLQƂł\t" + ae.Message);
                bytRet = Def.PTS_SYSTEMERR;
            }
            catch (ArgumentOutOfRangeException aoe)
            {   //grvSockClient.Send:offset p[^܂ count p[^An buffer ̗Lȗ̈OłBoffset ܂ count  0 łB 
                // G[Oo
                Common.outputLog("PtLan", "sockSend", "offsetAcountw~X\t" + aoe.Message);
                bytRet = Def.PTS_SYSTEMERR;
            }
            catch (SocketException se)
            {   //grvSockClient.Send:socketFlags Al̗Lȑgݍ킹ł͂܂B
                //grvSockClient.Send:Socket ɃANZXɃIy[eBO VXe G[܂B
                // G[Oo
                Common.outputLog("PtLan", "sockSend", "Iy[eBO VXe G[\t" + se.Message);
                bytRet = Def.PTS_SYSTEMERR;
            }
            catch (ObjectDisposedException ode)
            {   //grvSockClient.Send:Socket ͕Ă܂B 
                // G[Oo
                Common.outputLog("PtLan", "sockSend", "Socket ͕Ă܂\t" + ode.Message);
                bytRet = Def.PTS_SYSTEMERR;
            }
            catch (Exception e)
            {					//Error
                // G[Oo
                Common.outputLog("PtLan", "sockSend", e.Message);
                bytRet = Def.PTS_SYSTEMERR;
            }

            Common.outputDebugLog("PtLan", "sockSend", "====================================I====================================");
            return bytRet;
        }

        /// <summary>
        /// Mobt@ǂݎ̂
        /// </summary>
        /// <returns>
        /// M
        /// </returns>
        private void clrSockReceive()
        {
            int intReadLen;                     // ǂݍް
            byte[] bytRead;                     // Mf[^

            Common.outputDebugLog("PtLan", "clrSockReceive", "====================================Jn====================================");
            try
            {
                // ǎ\擾
                intReadLen = grvSockClient.Available;

                // ǎ\ްLH
                if (intReadLen > 0)
                {
                    bytRead = new byte[intReadLen];
                    // ǂݎ̂
                    grvSockClient.Receive(bytRead, 0, intReadLen, SocketFlags.None);
                }
            }
            catch (SocketException se)
            {	// grvSockClient.Available:\Pbgւ̃ANZX݂ĂƂɃG[܂B
                // grvSockClient.Receive():Socket ɃANZXɃIy[eBO VXe G[܂B
                // G[Oo
                Common.outputLog("PtLan", "clrSockReceive", "\Pbgւ̃ANZX݂ĂƂɃG[܂\t" + se.Message);
            }
            catch (ObjectDisposedException ode)
            {	//grvSockClient.Available:Socket ͕Ă܂B
                // grvSockClient.Receive():Socket ͕Ă܂B
                // G[Oo
                Common.outputLog("PtLan", "clrSockReceive", "Socket ͕Ă܂\t" + ode.Message);
            }
            catch (ArgumentNullException ae)
            {	// grvSockClient.Receive():buffer  null Q (Visual Basic ł Nothing) łB
                // G[Oo
                Common.outputLog("PtLan", "clrSockReceive", "buffer  null QƂł\t" + ae.Message);
            }
            catch (ArgumentOutOfRangeException aoe)
            {	// grvSockClient.Receive():offset p[^܂ count p[^An buffer ̗Lȗ̈OłBoffset ܂ count  0 łB 
                // G[Oo
                Common.outputLog("PtLan", "clrSockReceive", "offsetAcountw~X\t" + aoe.Message);
            }
            catch (Exception e)
            {	// Error
                // G[Oo
                Common.outputLog("PtLan", "clrSockReceive", e.Message);
            }

            Common.outputDebugLog("PtLan", "clrSockReceive", "====================================I====================================");
        }

        /// <summary>
        /// M
        /// </summary>
        /// <returns>
        /// M
        /// </returns>
        private PtReceiveData subSockReceive()
        {
            PtReceiveData rdtRet;               // ݺ
            int intReadLen;                     // ǂݍް
            Timer timTimeOut = null;            // ^CAEgĎ^C}[
            TimerCallback tcbTimeOut = null;    // ^CAEgɌĂԃ\bh

            // 
            rdtRet.ReceiveLen = 0;
            rdtRet.ReceiveData = new byte[0];
            rdtRet.Ret = Def.PTS_END_RECEIVE;

            Common.outputDebugLog("PtLan", "subSockReceive", "====================================Jn====================================");
            try
            {

                // ѱėLH
                if (grvPlpParam.Timeout > 0)
                {
                    // ^C}[Zbg
                    grvBlnTimeout = false;  // tO
                    tcbTimeOut = new TimerCallback(timReceiveTimer);
                    timTimeOut = new Timer(tcbTimeOut, null, grvPlpParam.Timeout, Timeout.Infinite);
                    Common.outputDebugLog("PtLan", "subSockReceive", "^C}[ZbgF" + grvPlpParam.Timeout);
                }

                while (true)
                {

                    // ǎ\擾
                    intReadLen = grvSockClient.Available;

                    Common.outputDebugLog("PtLan", "subSockReceive", "MoCgF" + intReadLen);

                    // ǎ\ްLH
                    if (intReadLen > 0)
                    {
                        // MZbg
                        rdtRet.ReceiveLen = intReadLen;

                        // M
                        rdtRet.ReceiveData = new byte[intReadLen];
                        grvSockClient.Receive(rdtRet.ReceiveData, 0, intReadLen, SocketFlags.None);
#if DEBUG
                        for (int ii = 0; ii < intReadLen; ii++)
                        {
                            Common.outputDebugLog("PtLan", "subSockReceive", "Mf[^F" + (char)rdtRet.ReceiveData[ii]);
                        }
#endif
                        break;  // M
                    }
                    else
                    {
                        // ~ꂽH
                        DoEvent();
                        if (PtChkStopFlg() == true)
                        {
                            Common.outputDebugLog("PtLan", "subSockReceive", "[U蒆~t");
                            rdtRet.Ret = Def.PTS_STOP;
                            break;
                        }

                        // ѱĔ肷H
                        if (grvPlpParam.Timeout > 0)
                        {
                            // ѱāH
                            DoEvent();
                            if (grvBlnTimeout == true)
                            {
                                Common.outputDebugLog("PtLan", "subSockReceive", "MѱĔ");
                                // v^艞L܂
                                rdtRet.Ret = Def.PTS_TIMEOUT;
                                break;
                            }
                        }
                    }
                }
            }
            catch (SocketException se)
            {	// grvSockClient.Available:\Pbgւ̃ANZX݂ĂƂɃG[܂B
                // grvSockClient.Receive():Socket ɃANZXɃIy[eBO VXe G[܂B
                // G[Oo
                Common.outputLog("PtLan", "subSockReceive", "\Pbgւ̃ANZX݂ĂƂɃG[܂\t" + se.Message);
                rdtRet.Ret = Def.PTS_SYSTEMERR;
            }
            catch (ObjectDisposedException ode)
            {	//grvSockClient.Available:Socket ͕Ă܂B
                // grvSockClient.Receive():Socket ͕Ă܂B
                // G[Oo
                Common.outputLog("PtLan", "subSockReceive", "Socket ͕Ă܂\t" + ode.Message);
                rdtRet.Ret = Def.PTS_SYSTEMERR;
            }
            catch (ArgumentNullException ae)
            {	// grvSockClient.Receive():buffer  null Q (Visual Basic ł Nothing) łB
                // G[Oo
                Common.outputLog("PtLan", "subSockReceive", "buffer  null QƂł\t" + ae.Message);
                rdtRet.Ret = Def.PTS_SYSTEMERR;
            }
            catch (ArgumentOutOfRangeException aoe)
            {	// grvSockClient.Receive():offset p[^܂ count p[^An buffer ̗Lȗ̈OłBoffset ܂ count  0 łB 
                // G[Oo
                Common.outputLog("PtLan", "subSockReceive", "offsetAcountw~X\t" + aoe.Message);
                rdtRet.Ret = Def.PTS_SYSTEMERR;
            }
            catch (Exception e)
            {	// Error
                // G[Oo
                Common.outputLog("PtLan", "subSockReceive", e.Message);
                rdtRet.Ret = Def.PTS_SYSTEMERR;
            }
            finally
            {
                // 
                if (timTimeOut != null)
                {
                    Common.outputDebugLog("PtLan", "subSockReceive", "^C}[ĎI");
                    timTimeOut.Dispose();
                }
            }

            Common.outputDebugLog("PtLan", "subSockReceive", "====================================I====================================");
            return rdtRet;
        }

        /// <summary>
        /// M
        /// </summary>
        /// <returns>
        /// M
        /// </returns>
        private PtReceiveData sockReceive()
        {
            PtReceiveData rdtRet;               // ݺ
            PtReceiveData rdtsrWork;            // M
            ArrayList arlReceiveData = new ArrayList();
            byte bytEndData;                    // Ō̎Mf[^

            // 
            rdtRet.ReceiveLen = 0;
            rdtRet.ReceiveData = new byte[0];
            rdtRet.Ret = Def.PTS_END_RECEIVE;

            Common.outputDebugLog("PtLan", "sockReceive", "====================================Jn====================================");
            try
            {

                while (true)
                {

                    // M
                    rdtsrWork = subSockReceive();

                    // MH
                    if (rdtsrWork.Ret == Def.PTS_END_RECEIVE)
                    {
                        if (rdtsrWork.ReceiveData[0] == Common.ACK || rdtsrWork.ReceiveData[0] == Common.NAK)
                        {
                            // MeZbg
                            rdtRet = rdtsrWork;
                            break;  // M
                        }
                        else if (rdtsrWork.ReceiveData[0] == Common.STX)
                        {
                            bytEndData = 0;
                            // Mf[^擾
                            for (int ii = 0; ii < rdtsrWork.ReceiveLen; ii++)
                            {
                                arlReceiveData.Add(rdtsrWork.ReceiveData[ii]);
                                if (rdtsrWork.ReceiveData[ii] == Common.ETX)
                                {
                                    bytEndData = rdtsrWork.ReceiveData[ii];
                                }
                            }

                            while (bytEndData != Common.ETX)    // ETXM܂ŌJԂ
                            {
                                // M
                                rdtsrWork = subSockReceive();

                                // MH
                                if (rdtsrWork.Ret == Def.PTS_END_RECEIVE)
                                {
                                    bytEndData = 0;
                                    // Mf[^擾
                                    for (int ii = 0; ii < rdtsrWork.ReceiveLen; ii++)
                                    {
                                        arlReceiveData.Add(rdtsrWork.ReceiveData[ii]);
                                        if (rdtsrWork.ReceiveData[ii] == Common.ETX)
                                        {
                                            bytEndData = rdtsrWork.ReceiveData[ii];
                                        }
                                    }
                                }
                                else
                                {
                                    rdtRet = rdtsrWork;
                                    break;  // I
                                }
                            }

                            Common.outputDebugLog("PtLan", "sockReceive", "Mf[^");

                            // Ƀf[^󂯎ꂽꍇ͎Mf[^Zbg
                            if (rdtsrWork.Ret == Def.PTS_END_RECEIVE)
                            {
                                // MZbg
                                rdtRet.ReceiveLen = arlReceiveData.Count;
                                // Mf[^Zbg
                                rdtRet.ReceiveData = new byte[rdtRet.ReceiveLen];
                                for (int ii = 0; ii < rdtRet.ReceiveLen; ii++)
                                {
                                    rdtRet.ReceiveData[ii] = (byte)arlReceiveData[ii];
                                }
                            }
                            break;  // M
                        }
                        else
                        {
                            // G[Oo
                            Common.outputDebugLog("PtLan", "sockReceive", "KO:" + rdtsrWork.ReceiveData[0]);
                            // Mp
                        }
                    }
                    else
                    {
                        // G[eZbg
                        rdtRet = rdtsrWork;
                        break;  // M
                    }
                }
            }
            catch (Exception e)
            {	// Error
                // G[Oo
                Common.outputLog("PtLan", "sockReceive", e.Message);
                rdtRet.Ret = Def.PTS_SYSTEMERR;
            }
            finally
            {
                arlReceiveData.Clear();
            }

            Common.outputDebugLog("PtLan", "sockReceive", "====================================I====================================");
            return rdtRet;
        }

        /// <summary>
        /// 󎚑MÕv^ԊmFs
        /// </summary>
        /// <returns>
        /// !NULL:
        /// </returns>
        private PtReceiveData PtChkPrintTransmissionCondition()
        {
            PtReceiveData prdResult;
            int intStRet = Common.STR_NOT_POS_RES;

            Common.outputDebugLog("PtLan", "PtChkPrintTransmissionCondition", "====================================Jn====================================");
            do
            {
                Common.outputDebugLog("PtLan", "PtChkPrintTransmissionCondition", "v^ԊmFJn");
                // v^̃Xe[^X擾
                prdResult = getPtStatus();
                Common.outputDebugLog("PtLan", "PtChkPrintTransmissionCondition", "v^ԊmFF" + prdResult.Ret);

                // Xe[^X擾
                if (prdResult.Ret == Def.PTS_END_RECEIVE)
                {
                    intStRet = Common.chkPrintTransmissionCondition(prdResult.ReceiveData[Common.STR_INDEX]);
                    Common.outputDebugLog("PtLan", "PtChkPrintTransmissionCondition", "Xe[^X́F" + intStRet);
                    // Xe[^XfEM\H
                    switch (intStRet)
                    {
                        case Common.STR_OK:             // \
                            break;
                        case Common.STR_STANDBY:        // ҋ@
                            grvIntOutputStatus = Def.PRN_PRINTING;  // 
                            break;
                        case Common.STR_WAIT_PASS: // ʉߒ
                            grvIntOutputStatus = Def.PRN_PASS_WAITING;  // ʉߒ
                            break;
                        case Common.STR_OFF_LINE:       // \(ItC)
                            grvIntOutputStatus = Def.PRN_OFF_LINE;  // ItC
                            DoEvent();
                            break;
                        case Common.STR_HEAD_OPEN:       // \(wbhI[v)
                            grvIntOutputStatus = Def.PRN_HEAD_OPEN;  // wbhI[v
                            DoEvent();
                            break;
                        case Common.STR_PAPER_END:      // \(y[p[Gh)
                            grvIntOutputStatus = Def.PRN_PAPER_END;  // y[p[Gh
                            DoEvent();
                            break;
                        case Common.STR_RIBON_END:       // \({Gh)
                            grvIntOutputStatus = Def.PRN_RIBON_END;  // {Gh
                            DoEvent();
                            break;
                        case Common.STR_SENSOR_ERROR:   // \(ZTG[)
                            grvIntOutputStatus = Def.PRN_SENSOR_ERROR;  // ZTG[
                            DoEvent();
                            break;
                        case Common.STR_COVER_OPENING:  // \(Jo[I[v)
                            grvIntOutputStatus = Def.PRN_COVER_OPENING;  // Jo[I[v
                            DoEvent();
                            break;
                        case Common.STR_INITIAL: // CjV
                            break; // ēxXe[^XmF
                        case Common.STR_NOT_POS_RES:    // s
                        default:
                            break;
                    }
                    Common.outputDebugLog("PtLan", "PtChkPrintTransmissionCondition", "OutputStatusF" + grvIntOutputStatus);
                }
                else
                {
                    // ُ팟m̂ߏI
                    break;
                }
            } while (intStRet != Common.STR_OK && intStRet != Common.STR_NOT_POS_RES);

            Common.outputDebugLog("PtLan", "PtChkPrintTransmissionCondition", "====================================I====================================");
            return prdResult;
        }

        /// <summary>
        /// 󎚊̊Ďs(xp)
        /// </summary>
        /// <returns>
        /// !NULL:
        /// </returns>
        private PtReceiveData PtChkPrintCompletionConditionLabel(bool checkFinishedCount)
        {
            PtReceiveData prdResult;
            int intStRet = Common.STR_NOT_POS_RES;

            Common.outputDebugLog("PtLan", "PtChkPrintCompletionConditionLabel", "====================================Jn====================================");
            do
            {
                Common.outputDebugLog("PtLan", "PtChkPrintCompletionConditionLabel", "v^ԊmFJn");
                // v^̃Xe[^X擾
                prdResult = getPtStatus();
                Common.outputDebugLog("PtLan", "PtChkPrintCompletionConditionLabel", "v^ԊmFF" + prdResult.Ret);

                // Xe[^X擾
                if (prdResult.Ret == Def.PTS_END_RECEIVE)
                {
                    intStRet = Common.chkPrintCompletionCondition(prdResult.ReceiveData[Common.STR_INDEX]);
                    Common.outputDebugLog("PtLan", "PtChkPrintCompletionConditionLabel", "Xe[^X́F" + intStRet);
                    // Xe[^XfEM\H
                    switch (intStRet)
                    {
                        case Common.STR_OK:             // 
                              if (checkFinishedCount && int.Parse(Encoding.GetEncoding("Shift_JIS").GetString(prdResult.ReceiveData.Skip(4).Take(6).ToArray())) <= 0)
                                // \tłȂΑҋ@
                                intStRet = Common.STR_STANDBY;
                            break;
                        case Common.STR_STANDBY:        // ҋ@
                            grvIntOutputStatus = Def.PRN_END_WAITING;  // ҂
                            break;
                        case Common.STR_WAIT_PASS: // ʉߒ
                            grvIntOutputStatus = Def.PRN_PASS_WAITING;  // ʉߒ
                            break;
                        case Common.STR_OFF_LINE:       // \(ItC)
                            grvIntOutputStatus = Def.PRN_OFF_LINE;  // ItC
                            DoEvent();
                            break;
                        case Common.STR_HEAD_OPEN:       // \(wbhI[v)
                            grvIntOutputStatus = Def.PRN_HEAD_OPEN;  // wbhI[v
                            DoEvent();
                            break;
                        case Common.STR_PAPER_END:      // \(y[p[Gh)
                            grvIntOutputStatus = Def.PRN_PAPER_END;  // y[p[Gh
                            DoEvent();
                            break;
                        case Common.STR_RIBON_END:       // \({Gh)
                            grvIntOutputStatus = Def.PRN_RIBON_END;  // {Gh
                            DoEvent();
                            break;
                        case Common.STR_SENSOR_ERROR:   // \(ZTG[)
                            grvIntOutputStatus = Def.PRN_SENSOR_ERROR;  // ZTG[
                            DoEvent();
                            break;
                        case Common.STR_COVER_OPENING:  // \(Jo[I[v)
                            grvIntOutputStatus = Def.PRN_COVER_OPENING;  // Jo[I[v
                            DoEvent();
                            break;
                        case Common.STR_INITIAL: // CjV
                            break; // ēxXe[^XmF
                        case Common.STR_NOT_POS_RES:    // s
                        default:
                            break;
                    }
                    Common.outputDebugLog("PtLan", "PtChkPrintCompletionConditionLabel", "OutputStatusF" + grvIntOutputStatus);
                }
                else
                {
                    // ُ팟m̂ߏI
                    break;
                }
            } while (intStRet != Common.STR_OK && intStRet != Common.STR_NOT_POS_RES);

            Common.outputDebugLog("PtLan", "PtChkPrintCompletionConditionLabel", "====================================I====================================");
            return prdResult;
        }

        /// <summary>
        /// XgbvtȌԂ`FbN
        /// </summary>
        /// <returns>
        /// trueFXgbv
        /// falseFs
        /// </returns>
        private bool PtChkStopFlg()
        {
            bool bolRet = false;

            if (grvBlnStopFlg == true)
            {
                grvBlnStopFlg = false;

                bolRet = true;
            }

            return bolRet;
        }

        /// <summary>
        /// ^CAEgĎ
        /// </summary>
        private void timReceiveTimer(Object stateInfo)
        {
            grvBlnTimeout = true;      // ^CAEgݒ
        }

        /// <summary>
        /// DoEvent
        /// </summary>
        private void DoEvent()
        {
            System.Windows.Forms.Application.DoEvents();
        }

        #endregion
    }
}
